#include<sep_params.h>
#include<sregf.h>
#include <seplib.h>
#include <vel_fd_3d.h>
#include <data_rtm_3d.h>
#include <image_rtm_3d.h>
#include "source_func_3d.h"
#include "rtm_zero_op_3d.h"
#include "gpu_funcs_3d.h"
#include "cgstep.h"
#include "lin_solver.h"
#include "tmute.h"

 main(int argc, char **argv){
 
   sep_params pars=sep_params(argc,argv);
   data_rtm_3d data=data_rtm_3d("data",&pars,true);
   data_rtm_3d bdata=data_rtm_3d("bdata",&pars,false);

   source_func wavelet=source_func("wavelet"); 
   axis asx=data.get_axis(4);
   axis asy=data.get_axis(5); //added
   int niter=pars.get_int("niter",5);
   float src_depth=pars.get_float("src_depth",0.);
   wavelet.set_sources_3d(src_depth,asx,asy);
   vel_fd_3d vel=vel_fd_3d("velocity");
   image_rtm_3d image=image_rtm_3d("image",&vel);
   image.zero();

   image.set_source_file(&image);

   oc_float *d1=new oc_float("main_data2.H",&data);
   data.set_source_file(d1);

   oc_float *d2=new oc_float("enc_data2.H",&bdata);
   bdata.set_source_file(d2);

   int n_gpus=pars.get_int("n_gpus",1);
   setup_cuda(n_gpus,argc,argv);

   float aper=pars.get_float("aper",8.);
//   int *rand_vec=0;

   int n_zs=pars.get_int("n_zeroes",0);
   int ns=data.get_axis(4).n*data.get_axis(5).n;
   int *rand_vec=new int[ns];
   float p_zs=(float)(100*n_zs/ns);
   //fprintf(stderr,"ns %d nzs %d %f\n",ns,n_zs,p_zs);

   bool encode=true;

   rtm_zero_op op=rtm_zero_op(&pars,&vel,&wavelet,&data,&bdata,&image,aper,true,true,rand_vec,n_zs,p_zs,false,true);

   //fprintf(stderr,"CREATING TEMP data \n");
   //op.forward(false,&image,d2);
   //oc_float *i2=new oc_float("iout.H",image.image);
   //i2->zero();
   //fprintf(stderr,"CREATING TEMP model\n");
  // op.adjoint(false,i2,d2);
  // seperr("");
  // op.dot_test(true);
  fprintf(stderr,"Iterations: %d \n",niter);

   cgstep *st=new cgstep();

   simple_solver *solv=new simple_solver(st,&bdata,&op);

   solv->set_verbose(3);
   solv->solve(niter);

   oc_float *mine=(oc_float*) solv->return_model();
   image.tagit="image";
   image.add(mine);

   return 0;

 }






