#include<sep_params.h>
#include<sregf.h>
#include <seplib.h>
#include <vel_fd_2d.h>
#include <data_rtm_2d.h>
#include <ext_image.h>
#include "source_func.h"
#include "rtm_zero_op.h"
#include "gpu_funcs.h"
#include "cgstep.h"
#include "lin_solver.h"

 main(int argc, char **argv){
 
   sep_params pars=sep_params(argc,argv);
   data_rtm_2d data=data_rtm_2d("data",&pars);
   source_func wavelet=source_func("wavelet"); 
   axis as=data.get_axis(3);
   float src_depth=pars.get_float("src_depth",0.);
   wavelet.set_sources_2d(src_depth,as);
   vel_fd_2d vel=vel_fd_2d("velocity");

   oc_float *d2=new oc_float("dtest.H",&data);
   data.set_source_file(d2);


   int dev=pars.get_int("device",0);
   setup_cuda(dev,argc,argv);
   float aper=pars.get_float("aper",8.);

   ext_image image=ext_image("image",&vel,&pars);
   image.zero();
   image.set_source_file(&image);
   image.write_description("image");

   //ext_image op2=ext_image(200,&data,&image,&field);
   //op2.dot_test(true);

   rtm_zero_op op=rtm_zero_op(&pars,&vel,&wavelet,&data,&image,aper,true);

   op.adjoint(false,&image,&data);

   return 0;
 }
       






