#include <sep_params.h>
#include <sregf.h>
#include <seplib.h>
#include <vel_fd_2d.h>
#include <data_rtm_2d.h>
#include <ext_image.h>
#include "source_func.h"
#include "rtm_zero_op.h"
#include "gpu_funcs.h"
#include "tmute.h"

 main(int argc, char **argv){

   sep_params pars=sep_params(argc,argv);
   data_rtm_2d data=data_rtm_2d("data",&pars);
   source_func wavelet=source_func("wavelet"); 

   axis as=data.get_axis(3);

   float src_depth=pars.get_float("src_depth",0.);
   wavelet.set_sources_2d(src_depth,as);
   vel_fd_2d vel=vel_fd_2d("velocity");
   ext_image image=ext_image("image",&vel,&pars);

   image.set_source_file(&image);

   oc_float *d1=new oc_float("data_tmp",&data);
   oc_float *d2=new oc_float("dataout",&data);

   data.set_source_file(d2);


   int dev=pars.get_int("device",0);
   setup_cuda(dev,argc,argv);
   float aper=pars.get_float("aper",8.);

   rtm_zero_op op=rtm_zero_op(&pars,&vel,&wavelet,&data,&image,aper,true,false,false);

   op.forward(false,&image,d2);

   /*oc_float *wt_space=data.clone();
   tmute tm=tmute(pars.get_float("tmute",.4),pars.get_float("vmute",1500.),wt_space,&data);
   tm.forward(false,d1,d2);*/

   return 0;
 }







