#include<sep_params.h>
#include<sregf.h>
#include <seplib.h>
#include <vel_fd_2d.h>
#include <data_rtm_2d.h>
#include <ext_image.h>
#include "source_func.h"
#include "rtm_zero_op.h"
#include "gpu_funcs.h"
#include "cgstep.h"
#include "lin_solver.h"
#include "tmute.h"
#include "blend.h"

 main(int argc, char **argv){
 
   sep_params pars=sep_params(argc,argv);
   data_rtm_2d data=data_rtm_2d("data",&pars);
   source_func wavelet=source_func("wavelet"); 
   axis as=data.get_axis(3);
   int niter=pars.get_int("niter",4);
   float src_depth=pars.get_float("src_depth",0.);
   wavelet.set_sources_2d(src_depth,as);
   vel_fd_2d vel=vel_fd_2d("velocity");
   ext_image image=ext_image("image",&vel,&pars);

   image.zero();
   image.set_source_file(&image);

   image.write_description("image");

   oc_float *d1=new oc_float("dtest.H",&data);
   data.set_source_file(d1);

   int dev=pars.get_int("device",0);

   setup_cuda(dev,argc,argv);
   float aper=pars.get_float("aper",8.);
   rtm_zero_op op=rtm_zero_op(&pars,&vel,&wavelet,&data,&image,aper,true,true,false);


  cgstep *st=new cgstep();
  //oc_float *wt_space=data.clone();
  //tmute tm=tmute(pars.get_float("tmute",.3),pars.get_float("vmute",1500.),wt_space,&data);
   op.adjoint(false,&image,&data);

   //oc_float *d2=new oc_float("dataout",&data);
   //data.set_source_file(d2);
   data_rtm_2d dataout=data_rtm_2d("data",&pars);
   oc_float *d2=new oc_float("dataout",&data);
   dataout.set_source_file(d2);
   d2->zero();


  //simple_solver *solv=new simple_solver(st,&data,&op);
  simple_solver *solv=new simple_solver(st,&image,&op);

  solv->set_verbose(3);
  solv->solve(niter);

  //oc_float *mine=(oc_float*) solv->return_model();
  oc_float *mine=(oc_float*) solv->return_model();

  dataout.tagit="dataout";
  //image.tagit="image";

  //image.add(mine);
  dataout.add(mine);


   return 0;
 }






