! Apply NMO operator
program NMO_operator

  use sep
  use Hradon_mod

  implicit none

  integer                           :: nz, ns, nt, nx
  real                              :: oz, dz, os, ds, ot, dt, ox, dx
  logical                           :: adj
  real, allocatable, dimension(:,:) :: model, data

  call sep_init()

  call from_param("adj", adj)

  if(adj) then
    call from_history("n1", nt)
    call from_history("o1", ot)
    call from_history("d1", dt)
    call from_history("n2", nx)
    call from_history("o2", ox)
    call from_history("d2", dx)
    call from_param("nz", nz)
    call from_param("oz", oz)
    call from_param("dz", dz)
    call from_param("ns", ns)
    call from_param("os", os)
    call from_param("ds", ds)
    call to_history("n1", nz)
    call to_history("o1", oz)
    call to_history("d1", dz)
    call to_history("n2", ns)
    call to_history("o2", os)
    call to_history("d2", ds)
    call to_history("label1", "z")
    call to_history("label2", "s")
  else
    call from_history("n1", nz)
    call from_history("o1", oz)
    call from_history("d1", dz)
    call from_history("n2", ns)
    call from_history("o2", os)
    call from_history("d2", ds)
    call from_param("nt", nt)
    call from_param("ot", ot)
    call from_param("dt", dt)
    call from_param("nx", nx)
    call from_param("ox", ox)
    call from_param("dx", dx)
    call to_history("n1", nt)
    call to_history("o1", ot)
    call to_history("d1", dt)
    call to_history("n2", nx)
    call to_history("o2", ox)
    call to_history("d2", dx)
    call to_history("label1", "t")
    call to_history("label2", "x")
  end if

  allocate(model(nz, ns))
  allocate(data(nt, nx))
  model = 0.
  data = 0.

  call nmo_init(nz, oz, dz, ns, os, ds, nt, ot, dt, nx, ox, dx)

  if(adj) then
    call sep_read(data)
    call nmo_op2(adj, .false., model, data)
    call sep_write(model)
  else
    call sep_read(model)
    call nmo_op2(adj, .false., model, data)
    call sep_write(data)
  end if

  call sep_close()

end program
