! Apply NMO operator
program NMO_operator3d_inv

!Transpose image first!!
  use sep
  use Hradon_mod
  use omp_lib
  use solver_mod
  use cgstep_mod

  implicit none

  integer                           :: nz, nhx, nzeta, np, n3, i3, niter
  real                              :: oz,dz,ohx,dhx,ozeta,dzeta,op,dp,o3,d3
  logical                           :: adj
  real, allocatable, dimension(:,:) :: model, data
  real, allocatable, dimension(:) :: model_tmp, data_tmp


  integer :: inode, node, nodes



  call sep_init()

  call from_param("nodes" ,nodes, 1)
  node =omp_get_num_procs()
  nodes=min(node-1,nodes)
  write(0,*) "Number of nodes available",node,"using",nodes

  call from_param("niter", niter,10)

  call from_history("n1", nz)
  call from_history("o1", oz)
  call from_history("d1", dz)
  call from_history("n2", nhx)
  call from_history("o2", ohx)
  call from_history("d2", dhx)
  call from_history("n3", n3)
  call from_history("o3", o3)
  call from_history("d3", d3)
  call from_param("nzeta", nzeta)
  call from_param("ozeta", ozeta)
  call from_param("dzeta", dzeta)
  call from_param("np", np)
  call from_param("op", op)
  call from_param("dp", dp)
  call to_history("n1", nzeta)
  call to_history("o1", ozeta)
  call to_history("d1", dzeta)
  call to_history("n2", np)
  call to_history("o2", op)
  call to_history("d2", dp)
  call to_history("n3", n3)
  call to_history("o3", o3)
  call to_history("d3", d3)
  call to_history("label1", "zeta")
  call to_history("label2", "p")
  call to_history("label3", "x")


  allocate(model(nzeta*np,n3))
  allocate(data(nz*nhx,n3))

  model = 0.
  data = 0.

  call omp_set_num_threads(nodes); 


!$OMP PARALLEL 
inode=omp_get_thread_num()
write(0,*) "Hi froom node",inode
!$OMP END PARALLEL


  call sep_read(data)
  data=data/maxval(data)

  call nmo_init(nzeta, ozeta, dzeta, np, op, dp, nz, oz, dz, nhx, ohx, dhx)


!$OMP PARALLEL DO ordered private(inode,i3,data_tmp,model_tmp) schedule(dynamic,1)
  do i3=1,n3

    if(allocated(model_tmp))deallocate(model_tmp);
    if(allocated(data_tmp))deallocate(data_tmp);
    allocate(model_tmp(nzeta*np),data_tmp(nz*nhx))

    data_tmp(:)=0.
    model_tmp(:)=0.

    data_tmp(:)=data(:,i3)
    !call nmo_init(nzeta, ozeta, dzeta, np, op, dp, nz, oz, dz, nhx, ohx, dhx)
    call solver_tiny(model_tmp, data_tmp, nmo_op, cgstep, niter)

    model(:,i3)=0.
    model(:,i3)=model_tmp(:)

    inode=omp_get_thread_num()
    write(0,*) "Finished ",i3,"/",n3,"on node",inode

  end do
!$OMP END PARALLEL DO

  call sep_write(model)






  call sep_close()

end program
