program Hradon_inv

  use sep
  use solver_mod
  use Hradon_mod
  use cgstep_mod

  implicit none

  integer                           :: nz, ns, nt, nx
  real                              :: oz, dz, os, ds, ot, dt, ox, dx
  integer                           :: niter
  real, allocatable, dimension(:)   :: model, data

  call sep_init()

  call from_history("n1", nt)
  call from_history("o1", ot)
  call from_history("d1", dt)
  call from_history("n2", nx)
  call from_history("o2", ox)
  call from_history("d2", dx)

  call from_param("nz", nz)
  call from_param("oz", oz)
  call from_param("dz", dz)
  call from_param("ns", ns)
  call from_param("os", os)
  call from_param("ds", ds)
  call from_param("niter", niter,10)

  call to_history("n1", nz)
  call to_history("o1", oz)
  call to_history("d1", dz)
  call to_history("n2", ns)
  call to_history("o2", os)
  call to_history("d2", ds)
  call to_history("label1", "z")
  call to_history("label2", "s")

  allocate(model(nz*ns))
  allocate(data(nt*nx))
  model = 0.
  data = 0.

  call nmo_init(nz, oz, dz, ns, os, ds, nt, ot, dt, nx, ox, dx)

  call sep_read(data)

  call solver_tiny(model, data, nmo_op, cgstep, niter)

  call sep_write(model)

  call sep_close()

end program
