! NMO operator module
module Hradon_mod

  implicit none
  integer, private :: nt, nx, nz, ns
  real, private    :: ot, dt, ox, dx, oz, dz, os, ds

  contains

  subroutine nmo_init(nz_in, oz_in, dz_in, ns_in, os_in, ds_in, nt_in, ot_in, dt_in, nx_in, ox_in, dx_in)
    integer             :: nz_in, ns_in, nt_in, nx_in
    real                :: oz_in, dz_in, os_in, ds_in, ot_in, dt_in, ox_in, dx_in
    nz = nz_in
    oz = oz_in
    dz = dz_in
    ns = ns_in
    os = os_in
    ds = ds_in
    nt = nt_in
    ot = ot_in
    dt = dt_in
    nx = nx_in
    ox = ox_in
    dx = dx_in
  end subroutine

  function nmo_op(adj, add, model, data) result(stat)
    logical,intent(in) :: adj, add
    real,dimension(:)  :: model, data
    integer            :: stat
    call nmo_op2(adj, add, model, data)
    stat=0
  end function

  subroutine nmo_op2(adj, add, model, data)
    logical,intent(in)       :: adj, add
    real, dimension(nz, ns)  :: model
    real, dimension(nt, nx)  :: data
    integer  :: iz, is, it, ix
    real     :: z, s, t, x, wt
    if(adj) then
      if(.not. add) model = 0.
      do is = 1,ns
        s = os + (is-1) * ds
        do ix = 1,nx
          x = ox + (ix-1) * dx
          do iz = 1,nz
            z = oz + (iz-1) * dz
	    !if(z .gt. 0) then
              t = sqrt(z*z + sign(1,int(s))*s*s*x*x)
            !else
            !  t = sqrt(z*z - s*s*x*x)
            !end if
            wt = (t-ot)/dt
            it = wt
            wt = wt - it
            it = it + 1
            if(it >= 1 .and. it+1 <= nt) then
              model(iz,is) = model(iz,is) + (1.-wt)*data(it,ix) + wt*data(it+1,ix)
            end if
          end do
        end do 
      end do
    else
      if(.not. add) data = 0.
      do is = 1,ns
        s = os + (is-1) * ds
        do ix = 1,nx
          x = ox + (ix-1) * dx
          do iz = 1,nz
            z = oz + (iz-1) * dz
	    !if(z .gt. 0) then
              t = sqrt(z*z + sign(1,int(s))*s*s*x*x)
            !else
            !  t = sqrt(z*z - s*s*x*x)
            !end if
            wt = (t-ot)/dt
            it = wt
            wt = wt - it
            it = it + 1
            if(it >= 1 .and. it+1 <= nt) then
              data(it,ix) = data(it,ix) + (1.-wt)*model(iz,is)
              data(it+1,ix) = data(it+1,ix) + wt*model(iz,is)
            end if
          end do
        end do 
      end do
    end if
  end subroutine

end module 
