! Apply linear Radon operator
program linear_radon

  use sep
  use lradon_mod

  implicit none

  integer                           :: nz, np, nt, nx
  real                              :: oz, dz, op, dp, ot, dt, ox, dx
  logical                           :: adj
  real, allocatable, dimension(:,:) :: model, data

  call sep_init()

  call from_param("adj", adj)

  if(adj) then
    call from_history("n1", nt)
    call from_history("o1", ot)
    call from_history("d1", dt)
    call from_history("n2", nx)
    call from_history("o2", ox)
    call from_history("d2", dx)
    call from_param("nz", nz)
    call from_param("oz", oz)
    call from_param("dz", dz)
    call from_param("np", np)
    call from_param("op", op)
    call from_param("dp", dp)
    call to_history("n1", nz)
    call to_history("o1", oz)
    call to_history("d1", dz)
    call to_history("n2", np)
    call to_history("o2", op)
    call to_history("d2", dp)
    call to_history("label1", "z")
    call to_history("label2", "p")
  else
    call from_history("n1", nz)
    call from_history("o1", oz)
    call from_history("d1", dz)
    call from_history("n2", np)
    call from_history("o2", op)
    call from_history("d2", dp)
    call from_param("nt", nt)
    call from_param("ot", ot)
    call from_param("dt", dt)
    call from_param("nx", nx)
    call from_param("ox", ox)
    call from_param("dx", dx)
    call to_history("n1", nt)
    call to_history("o1", ot)
    call to_history("d1", dt)
    call to_history("n2", nx)
    call to_history("o2", ox)
    call to_history("d2", dx)
    call to_history("label1", "t")
    call to_history("label2", "x")
  end if

  allocate(model(nz, np))
  allocate(data(nt, nx))
  model = 0.
  data = 0.

  call lradon_init(nz, oz, dz, np, op, dp, nt, ot, dt, nx, ox, dx)

  if(adj) then
    call sep_read(data)
    call lradon_op2(adj, .false., model, data)
    call sep_write(model)
  else
    call sep_read(model)
    call lradon_op2(adj, .false., model, data)
    call sep_write(data)
  end if

  call sep_close()

end program
