! Apply NMO operator
program radon_filter
!Transpose image first!!
  use sep
  use Hradon_mod
  use omp_lib

  implicit none

  integer                           :: nzeta, np, n3, i3, izeta, ip
  real                              :: ozeta,dzeta,op,dp,o3,d3,zeta,p
  logical                           :: adj
  real, allocatable, dimension(:,:,:) :: model, data

  integer :: inode, node, nodes
  node =omp_get_num_procs()
  write(0,*) "Number of nodes available",node

  call sep_init()

  call from_history("n1", nzeta)
  call from_history("o1", ozeta)
  call from_history("d1", dzeta)
  call from_history("n2", np)
  call from_history("o2", op)
  call from_history("d2", dp)
  call from_history("n3", n3)
  call from_history("o3", o3)
  call from_history("d3", d3)

  call to_history("n1", nzeta)
  call to_history("o1", ozeta)
  call to_history("d1", dzeta)
  call to_history("n2", np)
  call to_history("o2", op)
  call to_history("d2", dp)
  call to_history("n3", n3)
  call to_history("o3", o3)
  call to_history("d3", d3)

  call to_history("label1", "zeta")
  call to_history("label2", "p")
  call to_history("label3", "x")


  allocate(data(nzeta, np,n3))
  model = 0.
  data = 0.

  call omp_set_num_threads(nodes); 

  call sep_read(data)


  do i3=1,n3
    do ip=1,np
      p=op+(ip-1)*dp
      do izeta=1,nzeta
        zeta=ozeta+(izeta-1)*dzeta
        if(p .lt. 0) then
          data(izeta,ip,i3)=data(izeta,ip,i3)*exp(p)
        end if
        !if(p .lt. -8) then
        !  data(izeta,ip,i3)=0
        !end if
      end do
    end do
    write(0,*) "Finished ",i3,"/",n3
  end do




  call sep_write(data)
  deallocate(data)

  call sep_close()

end program
