#!/usr/bin/env python
import os
import sys
import commands
import random
import math

data = sys.argv[1]
nshots = int(sys.argv[2])
rec_length_percent = float(sys.argv[3])
shot_length = int(sys.argv[4])
fileout = sys.argv[5]
btype = int(sys.argv[6])
out_total = sys.argv[7]
verb = int(sys.argv[8])

shot=0
outs=" "

#btype=1 means random blending
#btype=2 means linear blending
#btype=3 means psuedo-linear blending

total_time = ((nshots+1)*shot_length*rec_length_percent)
shift_range=total_time-shot_length
#commands.getstatusoutput("touch %s"%(out_total))
#print "Total time is %d"%(total_time)
#commands.getstatusoutput("echo \"n1=%d n2=700 n3=1\" >> %s"%(total_time,out_total))
blendtimes=[]

print "Blend %d shots, originally each %d long, total %d long"%(nshots,shot_length,total_time)

#Initially blend all data into a long data set

for shot in range(0,nshots):
  tmpfile = "tmp.b.%s.H"%(shot)

  if btype==1:
    shift = int(random.randrange(1,shift_range+1))
  elif btype==2:
    shift = int(math.floor((shift_range/nshots))*(shot))
  elif btype==3:
    shift = int( math.floor((shift_range/nshots))*(shot)+ (random.randrange(-20,20)) )
    if shot==0:
      shift=0
    print(shift)

  #print "Shift per shot is %d, this shift is %d"%(shift_range/nshots,shift)
  blendtimes.append(shift)
  if verb==1:
    print "  Window3d n1=%d n3=1 f3=%d < %s | Pad beg1=%d end1=%d > %s"%(shot_length,shot,data,shift,(total_time-shift-shot_length),tmpfile)
  commands.getstatusoutput("Window3d n1=%d n3=1 f3=%d < %s | Pad beg1=%d end1=%d > %s"%(shot_length,shot,data,shift,(total_time-shift-shot_length),tmpfile))
  commands.getstatusoutput("echo \"o1=0.\" >> %s"%(tmpfile))

  #commands.getstatusoutput("cp %s %s"%(out_total,"tmp.b.H"))
  if shot==0:
    commands.getstatusoutput("Window3d n1=%d < %s > %s"%(total_time,tmpfile,out_total))
  else :
    commands.getstatusoutput("Window3d n1=%d < %s > %s"%(total_time,out_total,"tmp.b.H"))
  #commands.getstatusoutput("Cat3d axis=1 %s %s > %s"%(tmpfile,"tmp.b.H",out_total))
    if verb==1:
      print "  Add mode=sum %s %s > %s"%("tmp.b.H",tmpfile,out_total)
    commands.getstatusoutput("Add mode=sum %s %s > %s"%("tmp.b.H",tmpfile,out_total))

  commands.getstatusoutput("Rm tmp.b.%s.H"%(shot))

commands.getstatusoutput("Rm tmp.b.H")


print (blendtimes)

#Now let's cut up the dataset so it matches the original

for shot in range(0,nshots):
  tmpfile = "tmp.b.%s.H"%(shot)
  shift=blendtimes[shot]

  commands.getstatusoutput("Window3d n1=%s f1=%d < %s > %s"%(shot_length,shift,out_total,tmpfile))
  commands.getstatusoutput("echo \"o1=0.\" >> %s"%(tmpfile))

  if shot==0:
    commands.getstatusoutput("Window3d n1=%d < %s > %s"%(shot_length,tmpfile,fileout))
  else:
    commands.getstatusoutput("Window3d n1=%d < %s > %s"%(shot_length,fileout,"tmp.b.H"))
    commands.getstatusoutput("Cat3d axis=3 %s %s > %s"%("tmp.b.H",tmpfile,fileout))

  commands.getstatusoutput("Rm tmp.b.%s.H"%(shot))

commands.getstatusoutput("Rm tmp.b.H")

