#include "data_rtm_2d.h"
#include <math.h>

data_rtm_2d::data_rtm_2d(char *tg,param_func *par){
   tag_init(tg);
   //Should do sanity checks here

  axis a=get_axis(1);
  max_time=a.o+a.d*(a.n-1);
  max_time=max_time;
  //max_time=.2;
  dt=a.d;
  nt=a.n;
   rec_locs=0; data=0;
   dsamp=dt;
   sz=par->get_float("rec_depth",0.);
rec_depth=0.;
}

int data_rtm_2d::get_points(){
  return get_axis(2).n;
}

void data_rtm_2d::add_data(int ishot, hypercube_float *dat){

  sseek_block(myf->tagit.c_str(),get_axis(2).n*ishot,get_axis(1).n*4,0);
  hypercube_float *tmp=(hypercube_float*)dat->clone_zero();
  sreed(myf->tagit.c_str(),tmp->vals,get_axis(1).n*get_axis(2).n*4);
  for(int i=0; i < (int) tmp->get_n123(); i++) tmp->vals[i]+=dat->vals[i];
  sseek_block(myf->tagit.c_str(),get_axis(2).n*ishot,get_axis(1).n*4,0);
  srite(myf->tagit.c_str(),tmp->vals,get_axis(1).n*get_axis(2).n*4);
  delete tmp;

}

void data_rtm_2d::get_source_func(hypercube_float *domain, int ishot, 
float *s_z, float *s_x, int nsinc,  int nts,hypercube_float *time){
  axis a1=domain->get_axis(1);
  axis a2=domain->get_axis(2);
  axis at=get_axis(1);

  sseek_block(myf->tagit.c_str(),get_axis(2).n*ishot,get_axis(1).n*4,0);
  sreed(myf->tagit.c_str(),time->vals,get_axis(1).n*get_axis(2).n*4);
  float sx=get_axis(3).o+get_axis(3).d*ishot; 
sx=0;
  for(int i2=0; i2< get_axis(2).n; i2++){
    s_z[i2]=(sz-a1.o)/a1.d;
    s_x[i2]=(sx+get_axis(2).o+get_axis(2).d*i2-a2.o)/a2.d;

  }

}


