#ifndef GPU_FINITE_H
#define GPU_FINITE_H 1
#include <cutil.h>
#include <cuda.h>
#include "gpu_funcs.h"
//#define DEBUG
#if defined (DEBUG)
	#define _DBG printf("DBG: %d \n", __LINE__);
#else
	#define _DBG 
#endif

#define hloc(z,x) (z)+(x)*n1     /* host mem. z,x-coordinates to linear address converter */
#define dloc(z,x) (z)+(x)*n1gpu  /* device mem. z,x-coordinate to linear address converter */
#define min2(v1,v2) (((v1)<(v2))?(v1):(v2)) /* minimum function */

#define IMG_KERNEL 1

#define IK1_BLKSIZE 16 /* imaging kernel 1 & 2 variable */


__constant__ int n1gpu;
__constant__ int n2gpu;
__constant__ int n3gpu;


__constant__ float bc_agpu;
__constant__ float bc_bgpu;

__constant__ int nsrc_gpu;
__constant__ int nt_gpu;

__constant__ int *datageom_gpu0;
__constant__ float *data_gpu0;
__constant__ int *srcgeom_gpu0;
__constant__ float *source_gpu0; 
__constant__ int *src_loc,*rec_loc;
__constant__ float *sinc_s_table;
__constant__ float *sinc_d_table;

__constant__ int nsinc_gpu;
__constant__ int nextract_gpu;


__constant__ int dir_gpu;
__constant__ int *extract_geom0;

__constant__ int nrec_gpu;

__constant__ int ntrace_gpu;
__constant__ int hmax_gpu;
__constant__ int nh_gpu;
int *datageom_gpu;
int *srcgeom_gpu;
float *source_gpu;
float *data_gpu;
float *extract_gpu;
float *sincstable;
float *sincdtable;
int *extract_geom;
 cudaArray *vel_array1 ;
 cudaArray *vel_array2 ;

float *scale_s_gpu,*scale_g_gpu;
__device__ int min3(int v1,int v2,int v3){return min2(min2(v1,v2),v3);}
__device__ int min4(int v1,int v2,int v3,int v4){return min2(min2(v1,v2),min2(v3,v4));}
texture <float, 2, cudaReadModeElementType> vel_ref1;
texture <float, 2, cudaReadModeElementType> vel_ref2;


#endif
