#include "gpu_finite.h"
#include <stdlib.h>
#include "sep3d.h"
#include "seplib.h"  
#include "cudaErrors.cu"
#include "wave_fkernel.2d8o.cu"

double dd1,dd2;
extern "C" __global__ void extract_kernel(int it, float *extract_gpu,float *p){
	int i=blockIdx.x*blockDim.x+threadIdx.x;
	if(i<nextract_gpu){
	  extract_gpu[it*nextract_gpu+i]=p[extract_geom0[i]];
	}
}

extern "C" __global__ void new_src_inject_kernel(int it, int isinc,float *p){
	int i=blockIdx.x*blockDim.x+threadIdx.x;
                p[srcgeom_gpu0[i]]+=dir_gpu*(
        sinc_s_table[isinc*nsinc_gpu]*source_gpu0[ntrace_gpu*i+it]+
        sinc_s_table[isinc*nsinc_gpu+1]*source_gpu0[ntrace_gpu*i+it+1]+
	sinc_s_table[isinc*nsinc_gpu+2]*source_gpu0[ntrace_gpu*i+it+2]+
        sinc_s_table[isinc*nsinc_gpu+3]*source_gpu0[ntrace_gpu*i+it+3]+
	sinc_s_table[isinc*nsinc_gpu+4]*source_gpu0[ntrace_gpu*i+it+4]+                
        sinc_s_table[isinc*nsinc_gpu+5]*source_gpu0[ntrace_gpu*i+it+5]+
        sinc_s_table[isinc*nsinc_gpu+6]*source_gpu0[ntrace_gpu*i+it+6]+
        sinc_s_table[isinc*nsinc_gpu+7]*source_gpu0[ntrace_gpu*i+it+7]);


}
extern "C" __global__ void new_data_inject_kernel(int it, int isinc,float *p){
	int i=blockIdx.x*blockDim.x+threadIdx.x;
	if(i< nrec_gpu){
	  p[datageom_gpu0[i]]+=
            sinc_d_table[isinc*nsinc_gpu]*data_gpu0[ntrace_gpu*i+it] +
	    sinc_d_table[isinc*nsinc_gpu+1]*data_gpu0[ntrace_gpu*i+it+1]+
	    sinc_d_table[isinc*nsinc_gpu+2]*data_gpu0[ntrace_gpu*i+it+2]+
	    sinc_d_table[isinc*nsinc_gpu+3]*data_gpu0[ntrace_gpu*i+it+3]+
	    sinc_d_table[isinc*nsinc_gpu+4]*data_gpu0[ntrace_gpu*i+it+4]+
	    sinc_d_table[isinc*nsinc_gpu+5]*data_gpu0[ntrace_gpu*i+it+5]+
	    sinc_d_table[isinc*nsinc_gpu+6]*data_gpu0[ntrace_gpu*i+it+6]+
	    sinc_d_table[isinc*nsinc_gpu+7]*data_gpu0[ntrace_gpu*i+it+7];
	   
  }
}
extern "C" __global__ void new_data_extract_kernel(int it, int isinc,float *p){
	int i=blockIdx.x*blockDim.x+threadIdx.x;
	if(i<nrec_gpu){
	  data_gpu0[ntrace_gpu*i+it+0]+=p[datageom_gpu0[i]]*sinc_d_table[isinc*nsinc_gpu+0];
	  data_gpu0[ntrace_gpu*i+it+1]+=p[datageom_gpu0[i]]*sinc_d_table[isinc*nsinc_gpu+1];
	  data_gpu0[ntrace_gpu*i+it+2]+=p[datageom_gpu0[i]]*sinc_d_table[isinc*nsinc_gpu+2];
	  data_gpu0[ntrace_gpu*i+it+3]+=p[datageom_gpu0[i]]*sinc_d_table[isinc*nsinc_gpu+3];
	  data_gpu0[ntrace_gpu*i+it+4]+=p[datageom_gpu0[i]]*sinc_d_table[isinc*nsinc_gpu+4];
	  data_gpu0[ntrace_gpu*i+it+5]+=p[datageom_gpu0[i]]*sinc_d_table[isinc*nsinc_gpu+5];
	  data_gpu0[ntrace_gpu*i+it+6]+=p[datageom_gpu0[i]]*sinc_d_table[isinc*nsinc_gpu+6];
	  data_gpu0[ntrace_gpu*i+it+7]+=p[datageom_gpu0[i]]*sinc_d_table[isinc*nsinc_gpu+7];
	  
  }
}

extern "C" __global__ void img_kernel( float* img, float*dat, float*src){
	int i=blockIdx.x*blockDim.x+threadIdx.x;
	int j=blockIdx.y*blockDim.y+threadIdx.y;
	img[dloc(i,j)]+=.000001*dat[dloc(i,j)]*src[dloc(i,j)];
}

extern "C" __global__ void img_hx_kernel( float* img, float*dat, float*src, int ih){
	int i=blockIdx.x*blockDim.x+threadIdx.x;
	int j=blockIdx.y*blockDim.y+threadIdx.y;
        int h=ih-(hmax_gpu-1)/2;

        if(j > abs(h) && j < (n2gpu-abs(h))){
	  img[dloc(i,j)+(ih)*n1gpu*n2gpu]+=0.000001*dat[dloc(i,j+h)]*src[dloc(i,j-h)];
	}
        else{
	  //img[dloc(i,j)+(ih)*n1gpu*n2gpu]+=0.000001*dat[dloc(i,j)]*src[dloc(i,j)];
        }
}

extern "C" __global__ void img_hx_kernel_adj( float* dat, float *img, float*src, int ih){
	int i=blockIdx.x*blockDim.x+threadIdx.x;
	int j=blockIdx.y*blockDim.y+threadIdx.y;
        int h=ih-(hmax_gpu-1)/2;

        if(j > abs(h) && j < (n2gpu-abs(h))){
	  dat[dloc(i,j+h)]+=0.000001*img[dloc(i,j)+(ih)*n1gpu*n2gpu]*src[dloc(i,j-h)];
	}
        else{
	  //dat[dloc(i,j)]+=0.000001*img[dloc(i,j)+(ih)*n1gpu*n2gpu]*src[dloc(i,j)];
        }
}


extern "C" __global__ void img_add_kernel( float* img, float*rec_field, float *src_field){
	int i=blockIdx.x*blockDim.x+threadIdx.x;
	int j=blockIdx.y*blockDim.y+threadIdx.y;
	rec_field[dloc(i,j)]+=.000001*src_field[dloc(i,j)]*img[dloc(i,j)];
}

void setup_cuda(int device, int argc, char **argv){
  cudaSetDevice(device);
  int dr;
  cudaDeviceProp properties;
  cudaGetDeviceProperties(&properties,device);
  cudaDriverGetVersion(&dr);

  fprintf(stderr,"Using GPU %s (%d), driver %d \n",properties.name, device,dr);
}

void source_prop(int n1, int n2,bool damp, bool get_last, float *p0, float *p1, int jt,
int npts,int nt,int nextract, int *extract_pts, float *extracted,int jwave, char *tag){

  //ALLOCATE GPU MEMORY
  float *ptemp; 
  float *p0_gpu,*p1_gpu;
  cuda_call(cudaMalloc((void**) &p0_gpu,n1*n2*sizeof(float)));
  cuda_call(cudaMalloc((void**) &p1_gpu,n1*n2*sizeof(float)));
  
  //ZERO GPU MEMORY
  cuda_call(cudaMemset(p0_gpu, 0,n1*n2*sizeof(float)));
  cuda_call(cudaMemset(p1_gpu, 0,n1*n2*sizeof(float)));
  
  //SET SOURCE PROP DIRECTION
  int dir=1;
	cuda_call(cudaMemcpyToSymbol(dir_gpu, &dir, sizeof(float)));

  //GPU BLOCKS
  int nblocksx=(n1-2*FAT)/BLOCK_SIZE; /* remainder points will be ignored */
  int nblocksy=(n2-2*FAT)/BLOCK_SIZE; /* remainder points will be ignored */
  dim3 dimGrid(nblocksx,nblocksy);
  dim3 dimBlock(BLOCK_SIZE, BLOCK_SIZE);

  for(int it=0; it<nt; it++){

    //POINTERS INTO DATA ARRAY AND SINC ARRAY
    int id=it/jt;
    int i=it-id*jt;
	  //FORWARD PROPAGATE SOURCE
	 
	  if(damp==true){
  	  kernel_exec(wave_kernel2<<<dimGrid, dimBlock>>>(p0_gpu, p1_gpu, p0_gpu));
	    kernel_exec(damp_kernel<<<dimGrid, dimBlock>>>(p0_gpu, p1_gpu));
   }
   else{
    	  kernel_exec(wave_kernel<<<dimGrid, dimBlock>>>(p0_gpu, p1_gpu, p0_gpu));
   }
	

    //INJECT SOURCE	  
     kernel_exec(new_src_inject_kernel<<<1,npts>>>(id /*size of sinc*/,i, p0_gpu));

    //FLIP BUFFER POINTERS
    ptemp=p0_gpu; p0_gpu=p1_gpu;p1_gpu=ptemp;
  }

  //EXTRACT LAST WAVEFIELDS
  if(get_last){
    cuda_call(cudaMemcpy(p0, p0_gpu, n1*n2*sizeof(float), cudaMemcpyDeviceToHost));
    cuda_call(cudaMemcpy(p1, p1_gpu, n1*n2*sizeof(float), cudaMemcpyDeviceToHost));
  }

  cuda_call( cudaFree(source_gpu) );
  cuda_call( cudaFree(srcgeom_gpu));
  cuda_call( cudaFree(p0_gpu));
  cuda_call( cudaFree(p1_gpu));
}

void rtm_forward(int n1, int n2, int jt, float *img, float *dat, int npts_src, int npts,
int nt,int nt_big, int nrec,int nh){

  //ALLOCATE GPU SPACE   
  float *src_p0,*src_p1,*data_p0,*data_p1,*img_gpu,*img_hx_gpu;
  int n3=1;

  cuda_call(cudaMalloc((void**) &src_p0, n1*n2*n3*sizeof(float)));
  cuda_call(cudaMalloc((void**) &src_p1, n1*n2*n3*sizeof(float)));
  cuda_call(cudaMalloc((void**) &data_p0, n1*n2*n3*sizeof(float)));
  cuda_call(cudaMalloc((void**) &data_p1, n1*n2*n3*sizeof(float))); 
  cuda_call(cudaMalloc((void**) &img_gpu, n1*n2*n3*sizeof(float)));

  cuda_call(cudaMalloc((void**) &img_hx_gpu, n1*n2*nh*sizeof(float)));
  cuda_call(cudaMemcpy(img_hx_gpu, img, n1*n2*nh*sizeof(float), cudaMemcpyHostToDevice));
  cuda_call(cudaMemcpyToSymbol(hmax_gpu, &nh, sizeof(int)));

  //INITIALIZE GPU MEMORY
  cuda_call(cudaMemset(data_p0, 0,n1*n2*n3*sizeof(float)));
  cuda_call(cudaMemset(data_p1, 0,n1*n2*n3*sizeof(float)));
  cuda_call(cudaMemset(src_p0, 0,n1*n2*n3*sizeof(float)));
  cuda_call(cudaMemset(src_p1, 0,n1*n2*n3*sizeof(float))); 
  cuda_call(cudaMemset(data_gpu, 0,nt_big*nrec*sizeof(float))); 
  //cuda_call(cudaMemcpy(img_gpu, img, n1*n2*n3*sizeof(float), cudaMemcpyHostToDevice));
  
  //SET SOURCE PROPAGATION DIRECTION
  int dir=1;
  cuda_call(cudaMemcpyToSymbol(dir_gpu, &dir, sizeof(float)));
 
  //SET GPU GRID DIMENSIONS
   int nblocksx=(n1-2*FAT)/BLOCK_SIZE; /* remainder points will be ignored */
   int nblocksy=(n2-2*FAT)/BLOCK_SIZE; /* remainder points will be ignored */
   dim3 dimGrid(nblocksx,nblocksy);
   dim3 dimBlock(BLOCK_SIZE, BLOCK_SIZE);

   dim3 extGrid(n1/IK1_BLKSIZE,n2/IK1_BLKSIZE);
   dim3 extBlock(IK1_BLKSIZE,IK1_BLKSIZE);

  for(int it=0; it < nt; it++){

    //Pointer into data array and sync positon
    int id=it/jt;
    int i=it-id*jt;

    //Propagate data backwards (adjoint rather than inverse)
    kernel_exec(damp_kernel<<<dimGrid, dimBlock>>>(data_p0, data_p1));
    kernel_exec(damp_kernel<<<dimGrid, dimBlock>>>(data_p0, data_p1));

    wave_kernel_adj<<<dimGrid, dimBlock>>>(data_p0,data_p1,data_p0);

    kernel_exec(damp_kernel<<<dimGrid, dimBlock>>>(src_p0, src_p1));
    kernel_exec(damp_kernel<<<dimGrid, dimBlock>>>(src_p0, src_p1));

    //Propagate source forward 
    wave_kernel<<<dimGrid, dimBlock>>>(src_p0,src_p1,src_p0);


    //Inject source 
    new_src_inject_kernel<<<1,npts_src>>>(id /*size of sinc*/,i, src_p0);

    if(it%jt==0){
      for(int ih=0;ih<nh;ih++) img_hx_kernel_adj<<<extGrid, extBlock>>>(data_p0,img_hx_gpu,src_p0,ih);
    }

    //Extract data
    new_data_extract_kernel<<<(int)ceilf(1.*npts/100.),100>>>(id ,i, data_p0);//data_p0));
    float  *ptemp2=src_p1; src_p1=src_p0; src_p0=ptemp2;

    //Switch data pointers
    float *ptemp=data_p1; data_p1=data_p0; data_p0=ptemp;
  }

  //Copy gpu version of data back to CPU
  cudaMemcpy(dat, data_gpu, nt_big*nrec*sizeof(float), cudaMemcpyDeviceToHost);

  cudaFree(datageom_gpu);
  cudaFree(data_p0);
  cudaFree(data_gpu);
  cudaFree(img_gpu);
  cudaFree(source_gpu);
  cudaFree(srcgeom_gpu);
  cudaFree(data_p1);
  cudaFree(src_p0);
  cudaFree(src_p1);
  cudaFree(img_hx_gpu);

}



void rtm_adjoint(int n1, int n2, int jt, float *p0_s_cpu, float *p1_s_cpu, float *img,float *srcfld,float *recfld
 , int npts_src, int npts,int nt,int nh){

   //MEMORY ALLOCATION
   float *src_p0,*src_p1,*data_p0,*data_p1,*img_gpu,*img_hx_gpu;

   cuda_call(cudaMalloc((void**) &src_p0, n1*n2*sizeof(float)));
   cuda_call(cudaMalloc((void**) &src_p1, n1*n2*sizeof(float)));
   cuda_call(cudaMalloc((void**) &data_p0, n1*n2*sizeof(float)));
   cuda_call(cudaMalloc((void**) &data_p1, n1*n2*sizeof(float))); 
   cuda_call(cudaMalloc((void**) &img_gpu, n1*n2*sizeof(float)));
   cuda_call(cudaMemcpy(src_p0, p0_s_cpu, n1*n2*sizeof(float), cudaMemcpyHostToDevice));
   cuda_call(cudaMemcpy(src_p1, p1_s_cpu, n1*n2*sizeof(float), cudaMemcpyHostToDevice));
  
   //ZERO BUFFERS
   cuda_call(cudaMemset(data_p0, 0,n1*n2*sizeof(float)));
   cuda_call(cudaMemset(data_p1, 0,n1*n2*sizeof(float)));
   cuda_call(cudaMemset(img_gpu, 0,n1*n2*sizeof(float)));

   cuda_call(cudaMalloc((void**) &img_hx_gpu, n1*n2*nh*sizeof(float)));
   cuda_call(cudaMemset(img_hx_gpu, 0,n1*n2*nh*sizeof(float)));
   cuda_call(cudaMemcpyToSymbol(hmax_gpu, &nh, sizeof(int)));

   //SET SOURCE DIRECTION FOR REVERSE PROPAGATION
   int dir=-1;
   cuda_call(cudaMemcpyToSymbol(dir_gpu, &dir, sizeof(float)));

   //COPY SOURCE BUFFER FOR REVERSE PROPAGATION
   cuda_call(cudaMemcpy(src_p0, p0_s_cpu, n1*n2*sizeof(float), cudaMemcpyHostToDevice));
   cuda_call(cudaMemcpy(src_p1, p1_s_cpu, n1*n2*sizeof(float), cudaMemcpyHostToDevice));

   //BLOCKS FOR THE GPU
   int nblocksx=(n1-2*FAT)/BLOCK_SIZE; /* remainder points will be ignored */
   int nblocksy=(n2-2*FAT)/BLOCK_SIZE; /* remainder points will be ignored */
   dim3 dimGrid(nblocksx,nblocksy);
   dim3 dimBlock(BLOCK_SIZE, BLOCK_SIZE);

   //Blocks for extended imaging
   dim3 extGrid(n1/IK1_BLKSIZE,n2/IK1_BLKSIZE);
   dim3 extBlock(IK1_BLKSIZE,IK1_BLKSIZE);

   //IMAGING VS PROPAGATION STEPS FOR SOURCE SUBTRACT
   int id_s=(nt+1)/jt;     //SAMPLING IN DATA POINTER
   int i_s=(nt+1)-id_s*jt; //OFFSET FOR DATA POINTER

   //SUBTRACT OFF LAST SOURCE
   kernel_exec(new_src_inject_kernel<<<1,npts_src>>>(id_s /*size of sinc*/,i_s, src_p0));
   for(int it=nt-1; it >=0 ;it--){

     int id=it/jt;  //POINTER INTO DATA SAMPLING
     int i=it-id*jt;//OFFSET FROM DATA SAMPLING
     id_s=(it+1)/jt;//SAMPLING INTO SOURCE FIELD???
     i_s=it+1-id_s*jt;//OFFSET FROM SOURCE FIELD

     // kernel_exec(wave_kernel_damp<<<dimGrid, dimBlock>>>(data_p0,data_p1,data_p0));

     //REVERSE PROPAGATE DATA
     kernel_exec(wave_kernel2<<<dimGrid, dimBlock>>>(data_p0,data_p1,data_p0));
     kernel_exec(damp_kernel<<<dimGrid, dimBlock>>>(data_p0,data_p1));
     kernel_exec(damp_kernel<<<dimGrid, dimBlock>>>(data_p0,data_p1));

     //REVERSE PROPAGATE SOURCE
     kernel_exec(wave_kernel<<<dimGrid, dimBlock>>>(src_p0,src_p1,src_p0));

     //SUBTRACT OFF SOURCE 
     kernel_exec(new_src_inject_kernel<<<1,npts_src>>>(id_s /*size of sinc*/,i_s, src_p1));

     //INJECT DATA AT CURRENT TIME SAMPLE
     kernel_exec(new_data_inject_kernel<<<(int)ceilf(1.*npts/100.),100>>>(id ,i, data_p0));

     if(i==0){
       for(int ih=0;ih<nh;ih++) img_hx_kernel<<<extGrid,extBlock>>>(img_hx_gpu,data_p0,src_p0,ih);
     }

     //REVERSE FIELD POINTERS
     float *ptemp=data_p1; data_p1=data_p0; data_p0=ptemp;
     float  *ptemp2=src_p1; src_p1=src_p0; src_p0=ptemp2;

   }

  cuda_call(cudaMemcpy(img, img_hx_gpu, n1*n2*nh*sizeof(float), cudaMemcpyDeviceToHost));

  //FREE GPU MEMORY
  cuda_call( cudaFree(datageom_gpu));
  cuda_call( cudaFree(data_p0));
  cuda_call( cudaFree(data_gpu));
  cuda_call( cudaFree(img_gpu) );
  cuda_call( cudaFree(source_gpu) );
  cuda_call( cudaFree(srcgeom_gpu));
  cuda_call( cudaFree(data_p1));
  cuda_call( cudaFree(src_p0));
  cuda_call( cudaFree(src_p1));
  cudaFree(img_hx_gpu);

}



void transfer_sinc_table_s(int nsinc, int ns,  float **tables){
  float *tmp_table1=(float*)malloc(sizeof(float)*nsinc*ns);
  for(int i=0; i < ns; i++) memcpy((tmp_table1+nsinc*i),tables[i],nsinc*sizeof(float));
  cuda_call(cudaMalloc((void**) &sincstable,ns*nsinc*sizeof(float)));
  cuda_call(cudaMemcpy(sincstable, tmp_table1, ns*nsinc*sizeof(float),cudaMemcpyHostToDevice));
  cuda_call(cudaMemcpyToSymbol(sinc_s_table, &sincstable, sizeof(float*)));
  free(tmp_table1); //Might want to memcpytosymbol
  cuda_call(cudaMemcpyToSymbol(nsinc_gpu, &nsinc, sizeof(int)));
}

void transfer_sinc_table_d(int nsinc,  int nd, float **tabled){
   float *tmp_table2=(float*)malloc(sizeof(float)*nsinc*nd);
   for(int i=0; i < nd; i++) memcpy((tmp_table2+nsinc*i),tabled[i],nsinc*sizeof(float));
   cuda_call(cudaMalloc((void**) &sincdtable,nd*nsinc*sizeof(float)));
   cuda_call(cudaMemcpy(sincdtable, tmp_table2, nd*nsinc*sizeof(float),
   cudaMemcpyHostToDevice));
   cuda_call(cudaMemcpyToSymbol(sinc_d_table, &sincdtable, sizeof(float*)));
   free(tmp_table2);
}

void transfer_source_func(int npts, int nt, int *locs, float *vals){
  cuda_call(cudaMalloc((void**) &source_gpu,nt*npts*sizeof(float)));

  cuda_call(cudaMalloc((void**) &srcgeom_gpu,npts*sizeof(int)));
  cuda_call(cudaMemcpy(srcgeom_gpu, locs, npts*sizeof(int),cudaMemcpyHostToDevice));

  cuda_call(cudaMemcpy(source_gpu, vals, nt*npts*sizeof(float),cudaMemcpyHostToDevice));
  cuda_call(cudaMemcpyToSymbol(ntrace_gpu, &nt, sizeof(int)));

  cuda_call(cudaMemcpyToSymbol(srcgeom_gpu0, &srcgeom_gpu, sizeof(int*)));

  cuda_call(cudaMemcpyToSymbol(source_gpu0, &source_gpu, sizeof(float*)));

 }

void transfer_receiver_func(int npts, int nt, int *locs, float *vals){
  cuda_call(cudaMalloc((void**) &data_gpu,nt*npts*sizeof(float)));

  cuda_call(cudaMalloc((void**) &datageom_gpu,npts*sizeof(int)));
  cuda_call(cudaMemcpy(datageom_gpu, locs, npts*sizeof(int),cudaMemcpyHostToDevice));
		 
  cuda_call(cudaMemcpy(data_gpu, vals, nt*npts*sizeof(float),cudaMemcpyHostToDevice));
  cuda_call(cudaMemcpyToSymbol(ntrace_gpu, &nt, sizeof(int)));
  cuda_call(cudaMemcpyToSymbol(nrec_gpu, &npts, sizeof(int)));
  cuda_call(cudaMemcpyToSymbol(datageom_gpu0, &datageom_gpu, sizeof(int*)));

  cuda_call(cudaMemcpyToSymbol(data_gpu0, &data_gpu, sizeof(float*)));

}

void transfer_vel_func1(int nz, int nx, float *vel){
 cuda_call(cudaMemcpyToArray(vel_array1, 0,0, vel, nx*nz*sizeof(float), cudaMemcpyHostToDevice));
 cuda_call(cudaBindTextureToArray(vel_ref1, vel_array1));
}

void transfer_vel_func2(int nz, int nx, float *vel){
 cuda_call(cudaMemcpyToArray(vel_array2, 0,0, vel, nx*nz*sizeof(float), cudaMemcpyHostToDevice));
 cuda_call(cudaBindTextureToArray(vel_ref2, vel_array2));
} 

void create_gpu_space(float d1, float d2,float bc_a, float bc_b, int nz, int nx){
    int n1=nz;
    int n2=nx;
    cudaChannelFormatDesc cf1 = cudaCreateChannelDesc<float>();
    cuda_call(cudaMallocArray(&vel_array1, &cf1, n1, n2));  
    cudaChannelFormatDesc cf2 = cudaCreateChannelDesc<float>();
    cuda_call(cudaMallocArray(&vel_array2, &cf2, n1, n2));
    cuda_call(cudaMemcpyToSymbol(n1gpu, &n1, sizeof(int)));
    cuda_call(cudaMemcpyToSymbol(n2gpu, &n2, sizeof(int)));

    cuda_call(cudaMemcpyToSymbol(bc_agpu, &bc_a, sizeof(float)));
    cuda_call(cudaMemcpyToSymbol(bc_bgpu, &bc_b, sizeof(float)));
    float coeffs_cpu[COEFFS_SIZE]=get_coeffs((double)d1,(double)d2);
    dd1=1./(double)d1/(double)d1;
    dd2=1./(double)d2/(double)d2;
    cuda_call(cudaMemcpyToSymbol(coeffs, coeffs_cpu, COEFFS_SIZE*sizeof(float), 0,cudaMemcpyHostToDevice));

}

