#ifndef GPU_FUNC_H
#define GPU_FUNC_H 1

extern "C"{

void setup_cuda(int device, int argc, char **argv);


//void rtm_adjoint(int n1, int n2,  int j, float *p0_s_cpu, float *p1_s_cpu, float *img,int npts, int npp,int nt);
void rtm_adjoint(int n1, int n2,  int j, float *p0_s_cpu, float *p1_s_cpu, float *img,float *srcfld,float *recfld,int npts, int npp,int nt,int nh);

void rtm_forward(int n1, int n2, int jt, float *img, float *dat, int npts_src, int npts,int nt,int nt_big, int nrec, int nh);

void transfer_sinc_table_s(int nsinc, int ns,  float **tables);
void transfer_sinc_table_d(int nsinc, int ns,float **tabled);
void wavefield_debugging(char *file,char *tag,int n1, int n2, float *field);

void source_prop(int n1, int n2,bool damp, bool get_last, float *p0, float *p1, int jt, int npts,int nt, int nextract, int *extract_pts, float *extracted,int jwave, char *tag);

void transfer_source_func(int npts, int nt, int *locs, float *vals);
void transfer_receiver_func(int npts, int nt, int *locs, float *vals);
void transfer_vel_func1(int nz, int nx, float *vel);
void transfer_vel_func2(int nz, int nx, float *vel);


void create_gpu_space(float d1, float d2, float bc_a, float bc_b, int nz, int nx);
};
#endif
