#include "image_rtm_2d.h"
image_rtm_2d::image_rtm_2d(char *tg,vel_fd_2d *v){
  tagit=tg;
  image=new hypercube_float(v->fld);
  std::vector<axis> axes; axes.push_back(v->get_axis(1));
  axes.push_back(v->get_axis(2));
   init_nd(axes);
   auxinout(tg);
  write_description(tg);
   image->zero();
}

void image_rtm_2d::set_source_file(oc_float *ptr){
     myf=ptr;
     sseek(myf->tagit.c_str(),0,0);
     read_all(myf->tagit,image);    
}

void image_rtm_2d::add_image(hypercube_float *img){
  axis a1o=get_axis(1);
  axis a2o=get_axis(2);
  axis a1i=img->get_axis(1);
  axis a2i=img->get_axis(2);


int f2=(int)((a2i.o-a2o.o)/a2o.d);
int f1=(int)((a1i.o-a1o.o)/a1o.d);

for(int i2=0; i2 < a2i.n; i2++){
  if(i2+f2 >=0 && i2+f2 < a2o.n){
    for(int i1=0; i1 < a1i.n; i1++){
      if(i1+f1>=0 && i1+f1 <a1o.n){
         image->vals[i1+f1+(i2+f2)*a1o.n]+=img->vals[i1+i2*a1i.n];
      }
    }
   }
 }


}


float_2d *image_rtm_2d::extract_sub(axis a1i, axis a2i){
  axis a1o=get_axis(1);
  axis a2o=get_axis(2);

  sseek(myf->tagit.c_str(),0,0);

  read_all(myf->tagit,image);
  float_2d *img=new float_2d(a1i,a2i);

  img->zero();

int f2=(int)((a2i.o-a2o.o)/a2o.d);
int f1=(int)((a1i.o-a1o.o)/a1o.d);
for(int i2=0; i2 < a2i.n; i2++){
  if(i2+f2 >=0 && i2+f2 < a2o.n){
    for(int i1=0; i1 < a1i.n; i1++){
      if(i1+f1>=0 && i1+f1 <a1o.n){
        img->vals[i1+i2*a1i.n]=image->vals[i1+f1+(i2+f2)*a1o.n];

      }
    }
   }
 }


  return img;
}

void image_rtm_2d::write_volume(){
  sseek(myf->tagit.c_str(),0,0);
  write_all(myf->tagit,image);
}

