# 1 "<stdin>"
# 1 "<built-in>"
# 1 "<command-line>"
# 1 "<stdin>"
! Linear Radon operator module
module lradon_mod

  implicit none
  integer, private :: nt, nx, nz, np
  real, private :: ot, dt, ox, dx, oz, dz, op, dp

  contains

  subroutine lradon_init(nz_in, oz_in, dz_in, np_in, op_in, dp_in, nt_in, ot_in, dt_in, nx_in, ox_in, dx_in)
    integer :: nz_in, np_in, nt_in, nx_in
    real :: oz_in, dz_in, op_in, dp_in, ot_in, dt_in, ox_in, dx_in
    nz = nz_in
    oz = oz_in
    dz = dz_in
    np = np_in
    op = op_in
    dp = dp_in
    nt = nt_in
    ot = ot_in
    dt = dt_in
    nx = nx_in
    ox = ox_in
    dx = dx_in
  end subroutine

  function lradon_op(adj, add, model, data) result(stat)
    logical,intent(in) :: adj, add
    real,dimension(:) :: model, data
    integer :: stat
    call lradon_op2(adj, add, model, data)
    stat=0
  end function

  subroutine lradon_op2(adj, add, model, data)
    logical,intent(in) :: adj, add
    real, dimension(nz, np) :: model
    real, dimension(nt, nx) :: data
    integer :: iz, ip, it, ix
    real :: z, p, t, x
    if(adj) then
      if(.not. add) model = 0.
      do ip = 1,np
        p = op + (ip-1) * dp
        do ix = 1,nx
          x = ox + (ix-1) * dx
          do iz = 1,nz
            z = oz + (iz-1) * dz
            t = z + p*x
            it = 1.5 + (t-ot)/dt
            if(it >= 1 .and. it <= nt) then
              model(iz,ip) = model(iz,ip) + data(it,ix)
            end if
          end do
        end do
      end do
    else
      if(.not. add) data = 0.
      do ip = 1,np
        p = op + (ip-1) * dp
        do ix = 1,nx
          x = ox + (ix-1) * dx
          do iz = 1,nz
            z = oz + (iz-1) * dz
            t = z + p*x
            it = 1.5 + (t-ot)/dt
            if(it >= 1 .and. it <= nt) then
              data(it,ix) = data(it,ix) + model(iz,ip)
            end if
          end do
        end do
      end do
    end if
  end subroutine

end module
