#include "map_data.h"
#include "math.h"

map_data::map_data(int npt,float *s_z,float *s_x,int *locs, hypercube_float *model,
  hypercube_float *dom, hypercube_float *ran,int ntbig){

  scale=new float[npt];
  map=locs;
  
  ntb=ntbig;
  int ia=0;  
  int n1=model->get_axis(1).n;
  //for(int i3=0; i3 < npt/9; i3++){
  for(int i3=0; i3 < npt; i3++,ia++){
    int ix=(int)s_x[i3];
    int iz=(int)s_z[i3];
    float sm=0;
    //for(int i2=ix-1; i2 < ix+2; i2++){
      float xn=s_x[i3]-ix;
      //for(int i1=iz-1; i1< iz+2; i1++,ia++){
        float zn=s_z[i3]-iz;
        scale[ia]=expf(-zn*zn-xn*xn);
        map[ia]=iz+ix*n1;
//fprintf(stderr,"Map %d %d ; %d %d ; %d\n",iz,ix,i3,map[ia],n1);
        //sm+=scale[ia];
      //}
    //}
    /*ia-=9;
    float tt=0;
    for(int i=0; i < 9; i++) {
       scale[ia]=scale[ia]/sm;
       tt+=scale[ia];

      ia++;
    }*/
  }
  //set_domain(dom);
  //set_range(ran);
}



bool map_data::adjoint(bool add, my_vector *model, my_vector *data){
  float_2d *d=(float_2d*) data;
  float_2d *m=(float_2d*) model;
  if(!add) m->zero();
  int nt=d->get_axis(1).n;
  int n2=d->get_axis(2).n;
  //int ibig=0,ia=0;
  //fprintf(stderr,"CHECK DATA VALS %f \n",d->vals[0]);
  for(int i2=0; i2 < n2; i2++){
    //for(int i1=0; i1 < 9; i1++,ia++){
      for(int it=0; it < nt; it++/*,ibig++*/){
        //m->vals[ntb*ia+it+4]+=d->vals[it+i2*nt]*scale[ia];
        m->vals[ntb*i2+it+4]+=d->vals[it+i2*nt]/*scale[ia]*/;
      }
    //}
  }
}
bool map_data::forward(bool add, my_vector *model, my_vector *data){
  float_2d *d=(float_2d*) data;
  float_2d *m=(float_2d*) model;
  axis a1=d->get_axis(1);
  axis a2=d->get_axis(2);
  int nt=d->get_axis(1).n;
  int n2=d->get_axis(2).n;
  //float tt=0;
  //int ibig=0,ia=0;
  if(!add) d->zero();
    for(int i2=0; i2 < n2; i2++){
      //for(int i1=0; i1 < 9; i1++,ia++){
        for(int it=0; it < nt; it++/*,ibig++*/){
          //d->vals[it+i2*nt]+=m->vals[ntb*ia+it+4]*scale[ia];
          d->vals[it+i2*nt]+=m->vals[ntb*i2+it+4]/*scale[ia]*/;
      }
    //}
  } 

}

