#include "source_func.h"
#include<math.h>

source_func::source_func(char *tag){
   tag_init(tag);
   hypercube_float *tmp=new hypercube_float(this);
   wavelet=new hypercube_float(this);
   read_all(tag,tmp);
   wavelet->vals[get_axis(1).n-1]=0;
   for(int it=0; it < this->get_axis(1).n-1; it++) {
     wavelet->vals[it]=(tmp->vals[it+1]-tmp->vals[it])/tmp->get_axis(1).d;
}
   delete tmp;
   dt=get_axis(1).d;
   
}

void source_func::set_sources_2d(float s_z, axis src_axis){
  for(int i=0; i < src_axis.n; i++){
     sz.push_back(s_z);
     sx.push_back(src_axis.o+src_axis.d*i);
   }
}

int source_func::get_points( ){
 return 9;
}

void source_func::set_compute_size(hypercube *dom, float ap,int nbt, int nb,int fat,
  int blocksize){

  ax=dom->get_axis(2);
  az=dom->get_axis(1); 

  nbound=nb+fat; nboundt=nbt;
  aper=ap;

  ax.n+=2*nbound;
  az.n+=2*nbound;
  az.n+=nbt+nb+2*fat;

  int rem_x=ax.n-((int) (ax.n/16))*16;
  int rem_z=az.n-((int) (az.n/16))*16;

  if(rem_z!=0) rem_z=16-rem_z;
  if(rem_x!=0) rem_x=16-rem_x;

  ax.n+=rem_x;
  az.n+=rem_z;

  /*az=dom->get_axis(1);
  ax=dom->get_axis(2);
  nbound=nb+fat; nboundt=nbt;
  aper=ap;
  ax.n=(int)(ap/ax.d)*2+1+2*nbound;
  az.n=az.n+nbt+nb+fat*2;

  int t1=(ax.n-fat*2)/blocksize;
  int rem=ax.n-t1*blocksize-2*fat;
  if(rem!=0) rem=blocksize-rem;
  if(rem!=0) ax.n+=+rem;
    
  t1=(az.n-fat*2)/blocksize;
  rem=az.n-t1*blocksize-2*fat;
  if(rem!=0) rem=blocksize-rem;
  if(rem!=0) az.n+=+rem;


  az.o=az.o-(nbt+fat)*az.d;*/
  
}

hypercube_float *source_func::create_domain(int ishot){
  //ax.o=sx[ishot]-aper-ax.d*nbound;
  az.o=-az.d*nbound;
  ax.o=-ax.d*nbound;
  std::vector<axis>  axes; axes.push_back(az); axes.push_back(ax);
  hypercube_float *tmp=new hypercube_float(axes);
  return tmp; 
}


void source_func::get_source_func(hypercube_float *domain, int ishot, int nts,
int *locs, float *time){
  axis a1=domain->get_axis(1);
  axis a2=domain->get_axis(2);
  axis at=get_axis(1);
  float fx=(sx[ishot]-a2.o)/a2.d;
  float fz=(sz[ishot]-a1.o)/a1.d;
  int ix=(int)fx;
  int iz=(int)fz;
  int i=0;

  for(int it=0; it < nts*9; it++){
    time[it]=0;
  }
    for(int i2=ix-1; i2 <= ix+1; i2++){
    float xn=fx-i2;
    for(int i1=iz-1; i1<= iz+1; i1++,i++){
      float zn=fz-i1;
      locs[i]=i1+i2*a1.n;
      float scale=expf(-zn*zn-xn*xn);
  
      for(int it=0; it < at.n; it++){
        time[nts*i+it+4]=scale*wavelet->vals[it];
      }
    }
  } 
}


