#include "tmute.h"
#include "oc_float.h"

bool tmute::adjoint(bool add, my_vector *model, my_vector *data){
  oc_float *dat=(oc_float*) data;
  oc_float *mod=(oc_float*) model;
  if(!add) mod->zero();
   axis a1=dat->get_axis(1);
  axis a2=dat->get_axis(2);
  axis a3=dat->get_axis(3);
  std::vector<axis> as;
  as.push_back(a1); as.push_back(a2);
  hypercube_float *d=new hypercube_float(as);
  hypercube_float *m=new hypercube_float(as);
  sseek(dat->tagit.c_str(),0,0);
  sseek(mod->tagit.c_str(),0,0); 
  for(int i3=0; i3 < a3.n ;i3++){
    sreed(dat->tagit.c_str(),d->vals,a1.n*a2.n*4);
    sreed(mod->tagit.c_str(),m->vals,a1.n*a2.n*4);

    for(int i2=0; i2 < a2.n; i2++){
       float t0=t_0+(a2.o+a2.d*i2)/vmute;
      for(int i1=(int)((t0-a1.o)/a1.d); i1 < a1.n; i1++){
         m->vals [i2*a1.n+i1]+=d->vals[i2*a1.n+i1];
      }
    }
        sseek(mod->tagit.c_str(),-a1.n*a2.n*4,1);

    srite(mod->tagit.c_str(),m->vals,a1.n*a2.n*4);
  }
  delete d; delete m;

}
bool tmute::forward(bool add, my_vector *model, my_vector *data){
  oc_float *dat=(oc_float*) data;
  oc_float *mod=(oc_float*) model;
  axis a1=dat->get_axis(1);
  axis a2=dat->get_axis(2);
  axis a3=dat->get_axis(3);
  std::vector<axis> as;as.push_back(a1); as.push_back(a2);
  hypercube_float *d=new hypercube_float(as);
  hypercube_float *m=new hypercube_float(as);
  float sx,rx,t0,t;
fprintf(stderr,"Read from %s to %s \n",mod->tagit.c_str(),dat->tagit.c_str());
  if(!add) dat->zero();
  sseek(dat->tagit.c_str(),0,0);
  sseek(mod->tagit.c_str(),0,0);
  for(int i3=0; i3 < a3.n; i3++){
    sreed(dat->tagit.c_str(),d->vals,a1.n*a2.n*4);
    sreed(mod->tagit.c_str(),m->vals,a1.n*a2.n*4);
    sx=a3.o+a3.d*i3;
    for(int i2=0; i2 < a2.n; i2++){
       rx=a2.o+a2.d*i2;
       //if(sx>rx) t0=t_0+(sx-rx)/vmute;
       //else t0=t_0+(rx-sx)/vmute;
       t0=t_0+(abs(sx-rx))/vmute;
       for(int i1=0; i1 < a1.n; i1++){
	 t=a1.o+a1.d*i1;
         if(t>t0) d->vals [i2*a1.n+i1]+=m->vals[i2*a1.n+i1];
       }
    }
    sseek(dat->tagit.c_str(),-a1.n*a2.n*4,1);
    srite(dat->tagit.c_str(),d->vals,a1.n*a2.n*4);
  }

  delete d; delete m;

}

