#include "vel_fd_2d.h"
#include <math.h>
vel_fd_2d::vel_fd_2d(char *tag){
  tag_init(tag);
  fld=new hypercube_float(this);
  read_all(tag,fld);
//  fprintf(stderr,"!!! vel_fd_2d::vel_fd_2d , %c\n",*tag);
  dens=0;
  old=false;
  mid=false; 
  zero=false;
}
vel_fd_2d::vel_fd_2d(char *t1,char *t2){
  tag_init(t1);
  fld=new hypercube_float(this);
  read_all(t1,fld);
    dfile=new sregf(t2);
  dens=new hypercube_float(dfile);
  dfile->read_all(t2,dens);
  fprintf(stderr,"!!! vel_fd_2d::vel_fd_2d ");
 fprintf(stderr,"t1 t2 %c,%c\n ",*t1,*t2);
  old=false;
  zero=false;
  mid=false;
}

hypercube_float *vel_fd_2d::rand_subspace(int irand, int nrand1, int nrand2, 
float dt,
  hypercube_float *space){
  float vmax=max_vel();
    srand(irand);
    float dx2,dz2,rnd;
    std::vector<axis> axes; axes.push_back(space->get_axis(1));
    axes.push_back(space->get_axis(2));
    hypercube_float *tmp=new hypercube_float(axes);
    axis av_1=fld->get_axis(1);
    axis av_2=fld->get_axis(2);
//fprintf(stderr,"check on rand params %d,%d,%d\n",irand,nrand1,nrand2);
        float *temp=new float[axes[0].n*axes[1].n];
//   fprintf(stderr,"using rand_subspace  ");
    int i=0;
    for(int ix=0; ix < axes[1].n; ix++){
      int ix_v=MAX(0,MIN(av_2.n-1,
      (int)((axes[1].o+axes[1].d*
      ix-
      av_2.o)/
      av_2.d)));
      if(ix < nrand2) dx2=(float)((nrand2-ix)*(nrand2-ix))/(float)(nrand2*nrand2);
      else if(ix >= axes[1].n-nrand2) 
      dx2=(float)((ix-(axes[1].n-nrand2-1))*(ix-(axes[1].n-nrand2-1)))/(float)(nrand2*nrand2);
      else dx2=0;
      for(int iz=0; iz < axes[0].n; iz++,i++){
        int iz_v=MAX(0,MIN(av_1.n-1,(int)((axes[0].o+axes[0].d*iz-av_1.o)/av_1.d)));
        float val=fld->vals[iz_v+ix_v*av_1.n];   
        if(iz < nrand1) dz2=(float)(nrand1-iz)*(nrand1-iz)/(float)nrand1/(float)nrand1;
        else if(iz >= axes[0].n-nrand2) 
          dz2=(float)((iz-(axes[0].n-nrand2-1))*(iz-(axes[0].n-nrand2-1)))/(float)(nrand2*nrand2);
        else dz2=0;
        float dist=sqrtf(dx2+dz2);
        bool found=false;
        float dev;
        if(dist<.0001) found=true;
        else{
        //  val=val*1.03*(1.-MIN(1.,dist)*.83);
        }
        dev=0.;
        if(!old){
//                fprintf(stderr,"not old");
        while(!found && nrand2!=0){
//        fprintf(stderr,"!found && nrand2!=0");
          rnd=(float)rand()/RAND_MAX-.5-.49*dist;
          if(mid){ 
          rnd=-.49*dist;
        fprintf(stderr,"mid");
          }
          dev=rnd*1.3*dist*val; //4.6 is arbitrary;
          if(mid){
            found=true;
        fprintf(stderr,"mid");
            if(fabs(dev+val) > vmax*1.03*(1.-MIN(1.,dist)*.4) && dev+val <0.0001){
              dev=vmax*1.03*(1.-MIN(1.,dist)*.4-val);
           }
      
          }
          else{
            if(fabs(dev+val) < vmax*1.03*(1.-MIN(1.,dist)*.4) && dev+val >0.0001) found=true;
//        fprintf(stderr,"found && nrand2!=0");
          }
          if(zero) {
        fprintf(stderr,"zero");
         assert(1==2); 
         dev=0;
        }
        
        }
    
        }
        if(old){
        fprintf(stderr,"old");
         while(!found && nrand2!=0){
          rnd=(float)rand()/RAND_MAX-.5-.49*dist/(float)nrand2;
          dev=rnd*2.5*dist*val; //4.6 is arbitrary;
          if(fabs(dev+val) < vmax*1.03 && dev+val >0.0001) found=true;
          //fprintf(stderr,"CHECK IT %f %f %f %f\n",val,dev,dist,(float)nrand1);
        }
        
        }
      //   tmp->vals[i]=(val+dev);
//fprintf(stderr,"i in loop, %d\n",i);
 temp[i]=val+dev;
 tmp->vals[i]=(val+dev)*(val+dev)*dt*dt;
  
 //tmp->vals[i]=val+dev;
      }
    }

//srite("tmp.H",temp,4*(int)tmp->get_n123());
delete []temp;
    return tmp;
}
