#include "weight.h"
#include "float_3d.h"

weight::weight(hypercube_float *image, float z_0, float h_0){
  h0=h_0;
  z0=z_0;
  hmax=image->get_axis(3).o+image->get_axis(3).d*image->get_axis(3).n;
  z=0;
  h=0;
  set_domain(image);

}

bool weight::adjoint(bool add, my_vector *model, my_vector *data){
  float_3d *d=(float_3d*) data;
  float_3d *m=(float_3d*) model;
  if(!add) m->zero();
  axis a1=d->get_axis(1);
  axis a2=d->get_axis(2);
  axis a3=d->get_axis(3);

 for(int i3=0;i3<a3.n;i3++){
   h=a3.o+i3*a3.d;
   for(int i2=0;i2<a2.n;i2++){
    for(int i1=0;i1<a1.n;i1++){
      z=-z0+a1.o+i1*a1.d;
      if(z<0) z=0;
      m->vals[i1+i2*a1.n+i3*a1.n*a2.n]*=(z*(hmax-abs(h)+h0));
    }
   }
  }

}

bool weight::forward(bool add, my_vector *model, my_vector *data){
  float_3d *d=(float_3d*) data;
  float_3d *m=(float_3d*) model;
  if(!add) d->zero();
  axis a1=m->get_axis(1);
  axis a2=m->get_axis(2);
  axis a3=m->get_axis(3);

 for(int i3=0;i3<a3.n;i3++){
   h=a3.o+i3*a3.d;
   for(int i2=0;i2<a2.n;i2++){
    for(int i1=0;i1<a1.n;i1++){
      z=-z0+a1.o+i1*a1.d;
      if(z<0) z=0;
      d->vals[i1+i2*a1.n+i3*a1.n*a2.n]*=(z*(hmax-abs(h)+h0));
    }
   }
  }
}

