# 1 "<stdin>"
# 1 "<built-in>"
# 1 "<command-line>"
# 1 "<stdin>"

program weight
  use sep
  implicit none

  logical :: verb
  integer :: n1,n2,n3
  integer :: i1,i2,i3
  real :: d1,d2,d3
  real :: o1,o2,o3
  real :: z0,h0,h,z,hmax
  real, allocatable :: data(:,:,:),data_out(:,:,:)

  call sep_init()

  call from_history("n1",n1); call from_history("o1",o1,0.); call from_history("d1",d1,1.)
  call from_history("n2",n2); call from_history("o2",o2,0.); call from_history("d2",d2,1.)
  call from_history("n3",n3); call from_history("o3",o3,0.); call from_history("d3",d3,1.)

  call to_history("n1",n1); call to_history("d1",d1); call to_history("o1",o1)
  call to_history("n2",n2); call to_history("d2",d2); call to_history("o2",o2)
  call to_history("n3",n3); call to_history("o3",o3); call to_history("d3",d3)

  call from_param("z0",z0,0.)
  call from_param("h0",h0,1.)

  call sep_close()

  write(0,*) "Data dims ",n1,n2,n3
  write(0,*) "Depth from",o1,"To",o1+n1*d1
  write(0,*) "Hx from",o3,"To",o3+n3*d3
  write(0,*) "Begin z weight at ",z0,"Lowest h values at",h0

  allocate(data(n1,n2,n3),data_out(n1,n2,n3))
  call sep_read( data )
  hmax=o3+n3*d3

  do i3=1,n3
    h=o3+i3*d3
    !write(0,*) "Hx weight",hmax-abs(h)+h0
    do i2=1,n2
      do i1=1,n1
        z=-z0+o1+i1*d1
 if(z .lt. 0) then
          z=0.
        end if
 data_out(i1,i2,i3)=(data(i1,i2,i3)*z)*(hmax-abs(h)+h0)
      end do
    end do
  end do

  call sep_write(data_out)

! call exit(0)

end program weight
